MODULE CamJobBackup

    PROC BackupCamJobtoCtrl(var cameradev cam,bool replaceexistingfiles)
        VAR string ctrldirname:="HOME/IV";
        VAR dir camdirectory;
        VAR string camdirname;
        VAR string tempfilename;
        VAR string tempcamfilepath;
        VAR string tempctrlfilepath;

        camdirname:=CamGetName(cam)+":/";
        ctrldirname:=ctrldirname+CamGetName(cam)+"/";
        MakeDir ctrldirname;

        OpenDir camdirectory,camdirname;

        WHILE ReadDir(camdirectory,tempfilename) DO
            tempcamfilepath:=camdirname+tempfilename;
            tempctrlfilepath:=ctrldirname+tempfilename;
            CopyFile tempcamfilepath,tempctrlfilepath;
        ENDWHILE
        CloseDir camdirectory;

    ERROR
        IF ERRNO=ERR_FILEEXIST THEN
            IF replaceexistingfiles THEN
                RemoveFile tempctrlfilepath;
                RETRY;
            ELSE
                TRYNEXT;

            ENDIF
        ENDIF

    ENDPROC
ENDMODULE