MODULE RotateSuface_L
    
    PROC RotateAction(string step_last,string step_now)
        VAR string Sur_now;
        VAR string Sur_last;
        VAR num aQuater;
        VAR bool aClockWise;
        
        Sur_now:=StrPart(step_now,1,1);
        aQuater:=StrToByte(StrPart(step_now,2,1));
        
        Sur_last:=StrPart(step_last,1,1);
        
        IF aQuater=1 THEN
            aClockWise:=TRUE;
        ELSEIF aQuater=3 THEN
            aClockWise:=FALSE;
            aQuater:=1;
        ENDIF
        
        TEST Sur_now
            CASE "U":
            Transform Sur_last,Sur_now;
            RotateSurface0_LeftArm aClockWise,aQuater;
            
            CASE "R": 
            Transform Sur_last,Sur_now;
            RotateSurface1_LeftArm aClockWise,aQuater;
        
            CASE "D": 
            Transform Sur_last,Sur_now;
            RotateSurface2_LeftArm aClockWise,aQuater;
        
            CASE "L": 
            Transform Sur_last,Sur_now;
            RotateSurface3_LeftArm aClockWise,aQuater;
        
            CASE "F":
            Transform Sur_last,Sur_now;
            RotateSurface4_LeftArm aClockWise,aQuater;
        
            CASE "B":
            Transform Sur_last,Sur_now;
            RotateSurface5_LeftArm aClockWise,aQuater;
            
        ENDTEST
    ENDPROC

    
    PROC Transform(string slast, string snow)
        VAR string a;
        a:=slast+snow;
        
        TEST a
            CASE "UR":
            HandOverFrom0to1_LeftArm;
          
            CASE "UD":
            HandOverFrom0to2_LeftArm;
            
            CASE "UL":
            HandOverFrom0to3_LeftArm;
            
            CASE "UF":
            HandOverFrom0to4_LeftArm;
            
            CASE "UB":
            HandOverFrom0to5_LeftArm;
            
            CASE "RU":
            HandOverFrom1to0_LeftArm;
            
            CASE "RD":
            HandOverFrom1to2_LeftArm;
            
            CASE "RL":
            HandOverFrom1to3_LeftArm;
            
            CASE "RF":
            HandOverFrom1to4_LeftArm;
            
            CASE "RB":
            HandOverFrom1to5_LeftArm;
            
            CASE "DU":
            HandOverFrom2to0_LeftArm;
            
            CASE "DR":
            HandOverFrom2to1_LeftArm;
            
            CASE "DL":
            HandOverFrom2to3_LeftArm;
            
            CASE "DF":
            HandOverFrom2to4_LeftArm;
            
            CASE "DB":
            HandOverFrom2to5_LeftArm;
            
            CASE "LU":
            HandOverFrom3to0_LeftArm;
            
            CASE "LR":
            HandOverFrom3to1_LeftArm;
            
            CASE "LD":
            HandOverFrom3to2_LeftArm;
            
            CASE "LF":
            HandOverFrom3to4_LeftArm;
            
            CASE "LB":
            HandOverFrom3to5_LeftArm;
            
            CASE "FU":
            HandOverFrom4to0_LeftArm;
            
            CASE "FR":
            HandOverFrom4to1_LeftArm;
            
            CASE "FD":
            HandOverFrom4to2_LeftArm;
            
            CASE "FL":
            HandOverFrom4to3_LeftArm;
            
            CASE "FB":
            HandOverFrom4to5_LeftArm;
        
            CASE "BU":
            HandOverFrom5to0_LeftArm;
            
            CASE "BR":
            HandOverFrom5to1_LeftArm;
            
            CASE "BD":
            HandOverFrom5to2_LeftArm;
            
            CASE "BL":
            HandOverFrom5to3_LeftArm;
            
            CASE "BF":
            HandOverFrom5to4_LeftArm;
            
        ENDTEST      
        
    ENDPROC
    
    
!**********Real rotate***********************************************************************************
    
    PROC RotateSurface0_LeftArm(bool ClockWise,num quater)
        !Hold the cube and do nothing else
	ENDPROC

    PROC RotateSurface1_LeftArm(bool ClockWise,num quater)
        VAR robtarget p12;
        MoveL p11, LeftArmVelocity, fine, ServoL;
        GripperGrip;
        IF quater=2 THEN
            MoveJ RelTool(p11, 0, 0, 0 \Rz:=180), LeftArmVelocity, fine, ServoL;
        ELSEIF quater=1 THEN
            IF ClockWise THEN
                MoveJ RelTool(p11, 0, 0, 0 \Rz:=90), LeftArmVelocity, fine, ServoL;
            ELSE
                MoveJ RelTool(p11, 0, 0, 0 \Rz:=-90), LeftArmVelocity, fine, ServoL;
            ENDIF
        ELSE
            waittime 0.5;
        ENDIF
        GripperRelease;
        p12:=CRobT(\Tool:=ServoL);
        MoveL RelTool(p12, 0, 0, -20), LeftArmVelocity, z1, ServoL;
        MoveJ p10, LeftArmVelocity, z1, ServoL;
        
	ENDPROC
    
    PROC RotateSurface2_LeftArm(bool ClockWise,num quater)
        WaitSyncTask RotateSurface2_sync1, all_tasks;
        GripperRelease;
        MoveJ p20, LeftArmVelocity, fine, ServoL;
        
        WaitSyncTask RotateSurface2_sync2, all_tasks;
        
        WaitSyncTask RotateSurface2_sync3, all_tasks;
        MoveL p21, LeftArmVelocity, fine, ServoL;
        GripperGrip;
        
        WaitSyncTask RotateSurface2_sync4, all_tasks;
        
	ENDPROC
    
    PROC RotateSurface3_LeftArm(bool ClockWise,num quater)
        !Hold the cube and do nothing else
	ENDPROC
    
    PROC RotateSurface4_LeftArm(bool ClockWise,num quater)
        !Hold the cube and do nothing else
	ENDPROC
    
    PROC RotateSurface5_LeftArm(bool ClockWise,num quater)
        VAR robtarget p52;
        MoveL p51, LeftArmVelocity, fine, ServoL;
        GripperGrip;        
        IF quater=2 THEN
            MoveJ RelTool(p51, 0, 0, 0 \Rz:=180), LeftArmVelocity, fine, ServoL;
        ELSEIF quater=1 THEN
            IF ClockWise THEN
                MoveJ RelTool(p51, 0, 0, 0 \Rz:=90), LeftArmVelocity, fine, ServoL;
            ELSE
                MoveJ RelTool(p51, 0, 0, 0 \Rz:=-90), LeftArmVelocity, fine, ServoL;
            ENDIF
        ELSE
            waittime 0.5;
        ENDIF
        GripperRelease;
        p52:=CRobT(\Tool:=ServoL);
        MoveL RelTool(p52, 0, 0, -20), LeftArmVelocity, z1, ServoL;
        MoveJ p50, LeftArmVelocity, z1, ServoL;
	ENDPROC
    
!*************How to hold the Rubic Cube and then rotate 6 surfaces******************************
    
!from 0 to 1,2,3,4,5********************************************
    PROC HandOverFrom0to1_LeftArm()
        WaitSyncTask HandOver0to1_sync1, all_tasks;
        
        WaitSyncTask HandOver0to1_sync2, all_tasks;
        
        WaitSyncTask HandOver0to1_sync3, all_tasks;
        
        WaitSyncTask HandOver0to1_sync4, all_tasks;
        GripperRelease;
    
        WaitSyncTask HandOver0to1_sync5, all_tasks;
        MoveJ p00, LeftArmVelocity, z1, ServoL;
        
        WaitSyncTask HandOver0to1_sync6, all_tasks;
        MoveL p10, LeftArmVelocity, z1, ServoL;

    ENDPROC
    
    PROC HandOverFrom0to2_LeftArm()
        WaitSyncTask HandOver0to2_sync1, all_tasks;
        
        WaitSyncTask HandOver0to2_sync2, all_tasks;
        
        WaitSyncTask HandOver0to2_sync3, all_tasks;
        
        WaitSyncTask HandOver0to2_sync4, all_tasks;
        GripperRelease;
        
        WaitSyncTask HandOver0to2_sync5, all_tasks;
        MoveL p21, LeftArmVelocity, fine, ServoL;
        
        WaitSyncTask HandOver0to2_sync6, all_tasks;
        GripperGrip;
        
        WaitSyncTask HandOver0to2_sync7, all_tasks;
        
        WaitSyncTask HandOver0to2_sync8, all_tasks;

    ENDPROC
    
    PROC HandOverFrom0to3_LeftArm()
        WaitSyncTask HandOver0to3_sync1, all_tasks;
        
        WaitSyncTask HandOver0to3_sync2, all_tasks;
        
        WaitSyncTask HandOver0to3_sync3, all_tasks;
        
        WaitSyncTask HandOver0to3_sync4, all_tasks;
        GripperRelease;
        
        WaitSyncTask HandOver0to3_sync5, all_tasks;
        MoveL p31, LeftArmVelocity, fine, ServoL; 
        
        WaitSyncTask HandOver0to3_sync6, all_tasks;
        GripperGrip;
        
        WaitSyncTask HandOver0to3_sync7, all_tasks;
        
        WaitSyncTask HandOver0to3_sync8, all_tasks;

    ENDPROC

    PROC HandOverFrom0to4_LeftArm()
        WaitSyncTask HandOver0to4_sync1, all_tasks;
        
        WaitSyncTask HandOver0to4_sync2, all_tasks;
        
        WaitSyncTask HandOver0to4_sync3, all_tasks;
        
        WaitSyncTask HandOver0to4_sync4, all_tasks;
        GripperRelease;
        
        WaitSyncTask HandOver0to4_sync5, all_tasks;
        MoveL p00, LeftArmVelocity, z1, ServoL; 
        
        WaitSyncTask HandOver0to4_sync6, all_tasks;
        MoveFrom1to5_LeftArm;
        MoveJ p40, LeftArmVelocity, z1, ServoL; 
        
        WaitSyncTask HandOver0to4_sync7, all_tasks;
        MoveL p41, LeftArmVelocity, fine, ServoL; 
        
        WaitSyncTask HandOver0to4_sync8, all_tasks;
        GripperGrip;
        
        WaitSyncTask HandOver0to4_sync9, all_tasks;
        
        WaitSyncTask HandOver0to4_sync10, all_tasks;
        

    ENDPROC
    
    PROC HandOverFrom0to5_LeftArm()
        WaitSyncTask HandOver0to5_sync1, all_tasks;
        
        WaitSyncTask HandOver0to5_sync2, all_tasks;
        
        WaitSyncTask HandOver0to5_sync3, all_tasks;
    
        WaitSyncTask HandOver0to5_sync4, all_tasks;
        GripperRelease;
        
        WaitSyncTask HandOver0to5_sync5, all_tasks;
        MoveL p00, LeftArmVelocity, z1, ServoL;
        
        WaitSyncTask HandOver0to5_sync6, all_tasks;
        MoveFrom1to5_LeftArm;
        MoveJ p50, LeftArmVelocity, z1, ServoL;

    ENDPROC

    !from 1 to 0,2,3,4,5********************************************
    PROC HandOverFrom1to0_LeftArm()
        WaitSyncTask HandOver1to0_sync1, all_tasks;
        MoveJ p00, LeftArmVelocity, z1, ServoL;
        
        WaitSyncTask HandOver1to0_sync2, all_tasks;
        MoveL p01, LeftArmVelocity, fine, ServoL;
        
        WaitSyncTask HandOver1to0_sync3, all_tasks;
        GripperGrip;
        
        WaitSyncTask HandOver1to0_sync4, all_tasks;
        
        WaitSyncTask HandOver1to0_sync5, all_tasks;
        
        WaitSyncTask HandOver1to0_sync6, all_tasks;

    ENDPROC
    
    PROC HandOverFrom1to2_LeftArm()
        WaitSyncTask HandOver1to2_sync1, all_tasks;
        MoveJ p20, LeftArmVelocity, z1, ServoL;
        
        WaitSyncTask HandOver1to2_sync2, all_tasks;
        MoveL p21, LeftArmVelocity, fine, ServoL;
        
        WaitSyncTask HandOver1to2_sync3, all_tasks;
        GripperGrip;
        
        WaitSyncTask HandOver1to2_sync4, all_tasks;
        
        WaitSyncTask HandOver1to2_sync5, all_tasks;
        
        WaitSyncTask HandOver1to2_sync6, all_tasks;

    ENDPROC
    
    PROC HandOverFrom1to3_LeftArm()
        WaitSyncTask HandOver1to3_sync1, all_tasks;
        MoveJ p30, LeftArmVelocity, z1, ServoL;
        
        WaitSyncTask HandOver1to3_sync2, all_tasks;
        MoveL p31, LeftArmVelocity, fine, ServoL;
        
        WaitSyncTask HandOver1to3_sync3, all_tasks;
        GripperGrip;
        
        WaitSyncTask HandOver1to3_sync4, all_tasks;
        
        WaitSyncTask HandOver1to3_sync5, all_tasks;
        
        WaitSyncTask HandOver1to3_sync6, all_tasks;

    ENDPROC

    PROC HandOverFrom1to4_LeftArm()
        WaitSyncTask HandOver1to4_sync1, all_tasks;
        MoveFrom1to5_LeftArm;
        MoveJ p40, LeftArmVelocity, z1, ServoL;
        
        WaitSyncTask HandOver1to4_sync2, all_tasks;
        MoveL p41, LeftArmVelocity, fine, ServoL;
        
        WaitSyncTask HandOver1to4_sync3, all_tasks;
        GripperGrip;
        
        WaitSyncTask HandOver1to4_sync4, all_tasks;
        
        WaitSyncTask HandOver1to4_sync5, all_tasks;
        
        WaitSyncTask HandOver1to4_sync6, all_tasks;

    ENDPROC
    
    PROC HandOverFrom1to5_LeftArm()
        WaitSyncTask HandOver1to5_sync1, all_tasks;
        HandOverFrom1to3_LeftArm;
        
        WaitSyncTask HandOver1to5_sync2, all_tasks;
        HandOverFrom3to5_LeftArm;

    ENDPROC
    
    
    !from 2 to 0,1,3,4,5********************************************
    PROC HandOverFrom2to0_LeftArm()
        WaitSyncTask HandOver2to0_sync1, all_tasks;
        
        WaitSyncTask HandOver2to0_sync2, all_tasks;
        
        WaitSyncTask HandOver2to0_sync3, all_tasks;
        
        WaitSyncTask HandOver2to0_sync4, all_tasks;
        GripperRelease;
        
        WaitSyncTask HandOver2to0_sync5, all_tasks;
        MoveJ p01, LeftArmVelocity, fine, ServoL;
        
        WaitSyncTask HandOver2to0_sync6, all_tasks;
        GripperGrip;
        
        WaitSyncTask HandOver2to0_sync7, all_tasks;
        
        WaitSyncTask HandOver2to0_sync8, all_tasks;

    ENDPROC
    
    PROC HandOverFrom2to1_LeftArm()
        WaitSyncTask HandOver2to1_sync1, all_tasks;
        
        WaitSyncTask HandOver2to1_sync2, all_tasks;
              
        WaitSyncTask HandOver2to1_sync3, all_tasks;
        
        WaitSyncTask HandOver2to1_sync4, all_tasks;
        GripperRelease;
        
        WaitSyncTask HandOver2to1_sync5, all_tasks;
        MoveL p20, LeftArmVelocity, z1, ServoL;
        
        WaitSyncTask HandOver2to1_sync6, all_tasks;
        MoveL p10, LeftArmVelocity, z1, ServoL;

    ENDPROC
    
    PROC HandOverFrom2to3_LeftArm()
        WaitSyncTask HandOver2to3_sync1, all_tasks;
        
        WaitSyncTask HandOver2to3_sync2, all_tasks;
        
        WaitSyncTask HandOver2to3_sync3, all_tasks;
        
        WaitSyncTask HandOver2to3_sync4, all_tasks;
        GripperRelease;
        
        WaitSyncTask HandOver2to3_sync5, all_tasks;
        MoveL p31, LeftArmVelocity, fine, ServoL;
        
        WaitSyncTask HandOver2to3_sync6, all_tasks;
        GripperGrip;
        
        WaitSyncTask HandOver2to3_sync7, all_tasks;
        
        WaitSyncTask HandOver2to3_sync8, all_tasks;

    ENDPROC

    PROC HandOverFrom2to4_LeftArm()
        WaitSyncTask HandOver2to4_sync1, all_tasks;
        
        WaitSyncTask HandOver2to4_sync2, all_tasks;
        
        WaitSyncTask HandOver2to4_sync3, all_tasks;
        GripperRelease;
        
        WaitSyncTask HandOver2to4_sync4, all_tasks;
        MoveL p01, LeftArmVelocity, fine, ServoL;
        
        WaitSyncTask HandOver2to4_sync5, all_tasks;
        GripperGrip;
        
        WaitSyncTask HandOver2to4_sync6, all_tasks;
        
        WaitSyncTask HandOver2to4_sync7, all_tasks;
        
        WaitSyncTask HandOver2to4_sync8, all_tasks;
        
        WaitSyncTask HandOver2to4_sync9, all_tasks;

        WaitSyncTask HandOver2to4_sync10, all_tasks;
        
        WaitSyncTask HandOver2to4_sync11, all_tasks;
        GripperRelease;
        
        WaitSyncTask HandOver2to4_sync12, all_tasks;
        MoveL p20, LeftArmVelocity, z1, ServoL;
        
        WaitSyncTask HandOver2to4_sync13, all_tasks;
        MoveFrom1to5_LeftArm;
        MoveJ p40, LeftArmVelocity, z1, ServoL;
        
        WaitSyncTask HandOver2to4_sync14, all_tasks;
        MoveJ p41, LeftArmVelocity, fine, ServoL;
        
        WaitSyncTask HandOver2to4_sync15, all_tasks;
        GripperGrip;
        
        WaitSyncTask HandOver2to4_sync16, all_tasks;
        
        WaitSyncTask HandOver2to4_sync17, all_tasks;

    ENDPROC
    
    PROC HandOverFrom2to5_LeftArm()
        WaitSyncTask HandOver2to5_sync1, all_tasks;
        
        WaitSyncTask HandOver2to5_sync2, all_tasks;
        
        WaitSyncTask HandOver2to5_sync3, all_tasks;
        GripperRelease;
        
        WaitSyncTask HandOver2to5_sync4, all_tasks;
        MoveL p01, LeftArmVelocity, fine, ServoL;
        
        WaitSyncTask HandOver2to5_sync5, all_tasks;
        GripperGrip;
        
        WaitSyncTask HandOver2to5_sync6, all_tasks;
        
        WaitSyncTask HandOver2to5_sync7, all_tasks;
        
        WaitSyncTask HandOver2to5_sync8, all_tasks;
        
        WaitSyncTask HandOver2to5_sync9, all_tasks;
        
        WaitSyncTask HandOver2to5_sync10, all_tasks;
        
        WaitSyncTask HandOver2to5_sync11, all_tasks;
        GripperRelease;
        
        WaitSyncTask HandOver2to5_sync12, all_tasks;
        MoveL p20, LeftArmVelocity, z1, ServoL;
        
        WaitSyncTask HandOver2to5_sync13, all_tasks;
        MoveFrom1to5_LeftArm;
        MoveL p50, LeftArmVelocity, z1, ServoL;
        

    ENDPROC

    !from 3 to 0,1,2,4,5********************************************
    PROC HandOverFrom3to0_LeftArm()
        WaitSyncTask HandOver3to0_sync1, all_tasks;
        
        WaitSyncTask HandOver3to0_sync2, all_tasks;
        
        WaitSyncTask HandOver3to0_sync3, all_tasks;
        
        WaitSyncTask HandOver3to0_sync4, all_tasks;
        GripperRelease;
    
        WaitSyncTask HandOver3to0_sync5, all_tasks;
        MoveJ p01, LeftArmVelocity, fine, ServoL;
        
        WaitSyncTask HandOver3to0_sync6, all_tasks;
        GripperGrip;
        
        WaitSyncTask HandOver3to0_sync7, all_tasks;
        
        WaitSyncTask HandOver3to0_sync8, all_tasks;
        
        WaitSyncTask HandOver3to0_sync9, all_tasks;

    ENDPROC
    
    PROC HandOverFrom3to1_LeftArm()
        WaitSyncTask HandOver3to1_sync1, all_tasks;
        
        WaitSyncTask HandOver3to1_sync2, all_tasks;
              
        WaitSyncTask HandOver3to1_sync3, all_tasks;
        
        WaitSyncTask HandOver3to1_sync4, all_tasks;
        GripperRelease;
        
        WaitSyncTask HandOver3to1_sync5, all_tasks;
        MoveL p30, LeftArmVelocity, z1, ServoL;
        
        WaitSyncTask HandOver3to1_sync6, all_tasks;
        MoveL p10, LeftArmVelocity, z1, ServoL;   !p10=p30 not move

    ENDPROC
    
    PROC HandOverFrom3to2_LeftArm()
        WaitSyncTask HandOver3to2_sync1, all_tasks;
        
        WaitSyncTask HandOver3to2_sync2, all_tasks;
        
        WaitSyncTask HandOver3to2_sync3, all_tasks;
        
        WaitSyncTask HandOver3to2_sync4, all_tasks;
        GripperRelease;
        
        WaitSyncTask HandOver3to2_sync5, all_tasks;
        MoveL p21, LeftArmVelocity, fine, ServoL;
        
        WaitSyncTask HandOver3to2_sync6, all_tasks;
        GripperGrip;
        
        WaitSyncTask HandOver3to2_sync7, all_tasks;
        
        WaitSyncTask HandOver3to2_sync8, all_tasks;
        
        WaitSyncTask HandOver3to2_sync9, all_tasks;

    ENDPROC

    PROC HandOverFrom3to4_LeftArm()   ! 3->1 then 1->4
        WaitSyncTask HandOver3to4_sync1, all_tasks;
        
        WaitSyncTask HandOver3to4_sync2, all_tasks;

        WaitSyncTask HandOver3to4_sync3, all_tasks;
        
        WaitSyncTask HandOver3to4_sync4, all_tasks;
        GripperRelease;
        
        WaitSyncTask HandOver3to4_sync5, all_tasks;
        MoveL p30, LeftArmVelocity, z1, ServoL;
        
        WaitSyncTask HandOver3to4_sync6, all_tasks;
        MoveFrom1to5_LeftArm;
        MoveJ p40, LeftArmVelocity, z1, ServoL;
        
        WaitSyncTask HandOver3to4_sync7, all_tasks;
        MoveL p41, LeftArmVelocity, fine, ServoL;
        
        WaitSyncTask HandOver3to4_sync8, all_tasks;
        GripperGrip;
        
        WaitSyncTask HandOver3to4_sync9, all_tasks;
        
        WaitSyncTask HandOver3to4_sync10, all_tasks;
        
        WaitSyncTask HandOver3to4_sync11, all_tasks;

    ENDPROC
    
    PROC HandOverFrom3to5_LeftArm()
        WaitSyncTask HandOver3to5_sync1, all_tasks;
        
        WaitSyncTask HandOver3to5_sync2, all_tasks;
        
        WaitSyncTask HandOver3to5_sync3, all_tasks;
        
        WaitSyncTask HandOver3to5_sync4, all_tasks;
        GripperRelease;
        
        WaitSyncTask HandOver3to5_sync5, all_tasks;
        MoveL p30, LeftArmVelocity, z1, ServoL;
        
        WaitSyncTask HandOver3to5_sync6, all_tasks;
        MoveFrom1to5_LeftArm;
        MoveL p50, LeftArmVelocity, z1, ServoL;
        

    ENDPROC
    
        !from 4 to 0,1,2,3,5********************************************
    PROC HandOverFrom4to0_LeftArm()
        WaitSyncTask HandOver4to0_sync1, all_tasks;
        
        WaitSyncTask HandOver4to0_sync2, all_tasks;
        
        WaitSyncTask HandOver4to0_sync3, all_tasks;
        
        WaitSyncTask HandOver4to0_sync4, all_tasks;
        GripperRelease;

        WaitSyncTask HandOver4to0_sync5, all_tasks;
        MoveL p40, LeftArmVelocity, z1, ServoL;
        
        WaitSyncTask HandOver4to0_sync6, all_tasks;
        MoveFrom5to1_LeftArm;
        MoveJ p00, LeftArmVelocity, z1, ServoL;
        
        WaitSyncTask HandOver4to0_sync7, all_tasks;
        MoveL p01, LeftArmVelocity, fine, ServoL;
        
        WaitSyncTask HandOver4to0_sync8, all_tasks;
        GripperGrip;
        
        WaitSyncTask HandOver4to0_sync9, all_tasks;
        
        WaitSyncTask HandOver4to0_sync10, all_tasks;
        
        WaitSyncTask HandOver4to0_sync11, all_tasks;

    ENDPROC
    
    PROC HandOverFrom4to1_LeftArm()
        WaitSyncTask HandOver4to1_sync1, all_tasks;
        
        WaitSyncTask HandOver4to1_sync2, all_tasks;
              
        WaitSyncTask HandOver4to1_sync3, all_tasks;
        
        WaitSyncTask HandOver4to1_sync4, all_tasks;
        GripperRelease;
        
        WaitSyncTask HandOver4to1_sync5, all_tasks;
        MoveL p40, LeftArmVelocity, z1, ServoL;
        
        WaitSyncTask HandOver4to1_sync6, all_tasks;
        MoveFrom5to1_LeftArm;
        MoveJ p10, LeftArmVelocity, z1, ServoL;   

    ENDPROC
    
    PROC HandOverFrom4to2_LeftArm()
        
        WaitSyncTask HandOver4to2_sync1, all_tasks;
        
        WaitSyncTask HandOver4to2_sync2, all_tasks;
        
        WaitSyncTask HandOver4to2_sync3, all_tasks;
        
        WaitSyncTask HandOver4to2_sync4, all_tasks;
        GripperRelease;
        
        WaitSyncTask HandOver4to2_sync5, all_tasks;
        MoveL p40, LeftArmVelocity, z1, ServoL;
    
        WaitSyncTask HandOver4to2_sync6, all_tasks;
        MoveFrom5to1_LeftArm;
        MoveJ p10, LeftArmVelocity, z1, ServoL;
        
        WaitSyncTask HandOver4to2_sync7, all_tasks;
        MoveL p01, LeftArmVelocity, fine, ServoL;
        
        WaitSyncTask HandOver4to2_sync8, all_tasks;
        GripperGrip;
        
        WaitSyncTask HandOver4to2_sync9, all_tasks;
        
        WaitSyncTask HandOver4to2_sync10, all_tasks;
        
        WaitSyncTask HandOver4to2_sync11, all_tasks;
        
        WaitSyncTask HandOver4to2_sync12, all_tasks;
        
        WaitSyncTask HandOver4to2_sync13, all_tasks;
        
        WaitSyncTask HandOver4to2_sync14, all_tasks;
        GripperRelease;
        
        WaitSyncTask HandOver4to2_sync15, all_tasks;
        MoveL p21, LeftArmVelocity, fine, ServoL;
        
        WaitSyncTask HandOver4to2_sync16, all_tasks;
        GripperGrip;
        
        WaitSyncTask HandOver4to2_sync17, all_tasks;
        
    ENDPROC

    PROC HandOverFrom4to3_LeftArm()   
        WaitSyncTask HandOver4to3_sync1, all_tasks;
        HandOverFrom4to1_LeftArm;
        
        WaitSyncTask HandOver4to3_sync2, all_tasks;
        HandOverFrom1to3_LeftArm;


    ENDPROC
    
    PROC HandOverFrom4to5_LeftArm()
        WaitSyncTask HandOver4to5_sync1, all_tasks;
        
        WaitSyncTask HandOver4to5_sync2, all_tasks;
        
        WaitSyncTask HandOver4to5_sync3, all_tasks;
        
        WaitSyncTask HandOver4to5_sync4, all_tasks;
        GripperRelease;
        
        WaitSyncTask HandOver4to5_sync5, all_tasks;
        MoveL p40, LeftArmVelocity, z1, ServoL;
        
        WaitSyncTask HandOver4to5_sync6, all_tasks;
        MoveJ p50, LeftArmVelocity, z1, ServoL;
        

    ENDPROC
    
    !from 5 to 0,1,2,3,4********************************************
    PROC HandOverFrom5to0_LeftArm()
        WaitSyncTask HandOver5to0_sync1, all_tasks;
        MoveFrom5to1_LeftArm;
        MoveJ p00, LeftArmVelocity, z1, ServoL;
        
        WaitSyncTask HandOver5to0_sync2, all_tasks;
        MoveL p01, LeftArmVelocity, fine, ServoL;
        
        WaitSyncTask HandOver5to0_sync3, all_tasks;
        GripperGrip;
        
        WaitSyncTask HandOver5to0_sync4, all_tasks;
        
        WaitSyncTask HandOver5to0_sync5, all_tasks;
        
        WaitSyncTask HandOver5to0_sync6, all_tasks;

    ENDPROC
    
    PROC HandOverFrom5to1_LeftArm()
        WaitSyncTask HandOver5to1_sync1, all_tasks;
        HandOverFrom5to3_LeftArm;
        
        WaitSyncTask HandOver5to1_sync2, all_tasks;
        HandOverFrom3to1_LeftArm;

    ENDPROC
    
    PROC HandOverFrom5to2_LeftArm()
        WaitSyncTask HandOver5to2_sync1, all_tasks;
        MoveFrom5to1_LeftArm;
        MoveJ p10, LeftArmVelocity, z1, ServoL;
        
        WaitSyncTask HandOver5to2_sync2, all_tasks;
        MoveL p01, LeftArmVelocity, fine, ServoL;  !hold two layers
        
        WaitSyncTask HandOver5to2_sync3, all_tasks;
        GripperGrip;
        
        WaitSyncTask HandOver5to2_sync4, all_tasks;
        
        WaitSyncTask HandOver5to2_sync5, all_tasks;
        
        WaitSyncTask HandOver5to2_sync6, all_tasks;
        
        WaitSyncTask HandOver5to2_sync7, all_tasks;
        
        WaitSyncTask HandOver5to2_sync8, all_tasks;
        
        WaitSyncTask HandOver5to2_sync9, all_tasks;
        GripperRelease;
        
        WaitSyncTask HandOver5to2_sync10, all_tasks;
        MoveL p21, LeftArmVelocity, fine, ServoL;
        
        WaitSyncTask HandOver5to2_sync11, all_tasks;
        GripperGrip;
        
        WaitSyncTask HandOver5to2_sync12, all_tasks;
        
        WaitSyncTask HandOver5to2_sync13, all_tasks;

    ENDPROC
    
    PROC HandOverFrom5to3_LeftArm()
        WaitSyncTask HandOver5to3_sync1, all_tasks;
        MoveFrom5to1_LeftArm;
        MoveJ p30, LeftArmVelocity, z1, ServoL;
        
        WaitSyncTask HandOver5to3_sync2, all_tasks;
        MoveL p31, LeftArmVelocity, fine, ServoL;
        
        WaitSyncTask HandOver5to3_sync3, all_tasks;
        GripperGrip;
        
        WaitSyncTask HandOver5to3_sync4, all_tasks;
        
        WaitSyncTask HandOver5to3_sync5, all_tasks;
        
        WaitSyncTask HandOver5to3_sync6, all_tasks;

    ENDPROC

    PROC HandOverFrom5to4_LeftArm()
        WaitSyncTask HandOver5to4_sync1, all_tasks;
        MoveJ p40, LeftArmVelocity, z1, ServoL;
        
        WaitSyncTask HandOver5to4_sync2, all_tasks;
        MoveL p41, LeftArmVelocity, fine, ServoL;
        
        WaitSyncTask HandOver5to4_sync3, all_tasks;
        GripperGrip;
        
        WaitSyncTask HandOver5to4_sync4, all_tasks;
        
        WaitSyncTask HandOver5to4_sync5, all_tasks;
        
        WaitSyncTask HandOver5to4_sync6, all_tasks;

    ENDPROC


!    PROC GripperRelease()
!        !g_MoveTo 60\NoWait;
!        Reset DO_0_G_L;
!        Set DO_1_R_L;
!        WaitTime 0.3;
!        GripperFlag:=0;
!    ENDPROC
    
!    PROC GripperGrip()
!        !g_MoveTo 55\NoWait;
!        Reset DO_1_R_L;
!        Set DO_0_G_L;
!        WaitTime 0.3;
!        GripperFlag:=1;
!    ENDPROC
    
    PROC MoveFrom1to5_LeftArm()
        MoveJ p1253, LeftArmVelocity, z30, ServoL; 
        MoveJ p1252, LeftArmVelocity, z30, ServoL; 
        MoveJ p1251, LeftArmVelocity, z30, ServoL; 
    ENDPROC

    PROC MoveFrom5to1_LeftArm()
        MoveJ p1251, LeftArmVelocity, z30, ServoL; 
        MoveJ p1252, LeftArmVelocity, z30, ServoL; 
        MoveJ p1253, LeftArmVelocity, z30, ServoL; 
    ENDPROC

ENDMODULE