MODULE DisorderCube_R

    PROC DisorderCube_RightArm()

        WaitSyncTask DisorderCube_sync1,all_tasks;

        RotateAction "L1",DisorderCubeStep{1};

        FOR i FROM 2 TO 9 DO
            RotateAction DisorderCubeStep{i-1},DisorderCubeStep{i};
        ENDFOR

        Transform StrPart(DisorderCubeStep{9},1,1),"F";

    ENDPROC

    PROC ShowAround_RightArm()
        WaitSyncTask ShowAround_sync1,all_tasks;

        WaitSyncTask ShowAround_sync2,all_tasks;
        GripperRelease;
        MoveL p10,RightArmVelocity,fine,ServoR;

        WaitSyncTask ShowAround_sync3,all_tasks;
        IF not solveable THEN 
        rHome;            
        ExitCycle;
        ENDIF  
        WaitSyncTask ShowAround_sync4,all_tasks;
        MoveL p11,RightArmVelocity,fine,ServoR;

        WaitSyncTask ShowAround_sync5,all_tasks;
        GripperGrip;

        WaitSyncTask ShowAround_sync6,all_tasks;

    ENDPROC

    PROC ColorWrong()
        MoveJ pCamera02,RightArmVelocity,z30,ServoR;
        MoveJ pCamera01,RightArmVelocity,z30,ServoR;
        MoveJ pCamera02,RightArmVelocity,z30,ServoR;
        MoveJ pCamera01,RightArmVelocity,z30,ServoR;
    ENDPROC

    PROC ShowResult_RightArm()
        WaitSyncTask ShowResult_sync1,all_tasks;
        MoveJ p70,v300,z30,ServoR;
        MoveJ p71,v300,z30,ServoR;
        MoveJ p72,v300,z30,ServoR;
        MoveJ p73,v300,z30,ServoR;

        WaitSyncTask ShowResult_sync2,all_tasks;

        WaitSyncTask ShowResult_sync3,all_tasks;
        MoveJ p74,v300,z30,ServoR;
        MoveJ p73,v300,z30,ServoR;

        WaitSyncTask ShowResult_sync4,all_tasks;
        MoveJ p74,v300,z30,ServoR;
        MoveJ p73,v300,z30,ServoR;

        WaitSyncTask ShowResult_sync5,all_tasks;
        MoveJ p72,v300,z30,ServoR;
        MoveJ p71,v300,z30,ServoR;
        MoveJ p70,v300,z30,ServoR;
        !MoveJ p10, v300, z30, ServoR;

    ENDPROC

ENDMODULE