MODULE MotionForCamera_R
    CONST robtarget pCamera11:=[[273.68,-147.31,210.23],[0.70448,-0.709513,-0.0122146,0.0122782],[1,-1,2,11],[-130.812,9E+09,9E+09,9E+09,9E+09,9E+09]];
    
    PROC Initiate_RightArm()
        GripperRelease;
        MoveJ p10, RightArmVelocity, fine, ServoR; 
    ENDPROC
    
    PROC CaptureSurface0_RightArm()
        WaitSyncTask CaptureSurface0_sync1, all_tasks;
        MoveL p11, v100, fine, ServoR; 
        GripperGrip;
        
        WaitSyncTask CaptureSurface0_sync2, all_tasks;
        
        WaitSyncTask CaptureSurface0_sync3, all_tasks;
        
        MoveJ pCamera02, RightArmVelocity, z30, ServoR;
        
       ! MoveL pCamera01, RightArmVelocity, fine, ServoR;
    
        MoveJ pCamera01, RightArmVelocity, fine, ServoR; 
        
        !stop;
        
        !MoveJ [[312.70,-133.90,337.22],[0.720855,-0.691958,-0.0240287,-0.0313875],[1,0,2,11],[-164.065,9E+09,9E+09,9E+09,9E+09,9E+09]],RightArmVelocity, FINE, ServoR;
        !WaitTime 1;
        
        !Modified TCH ColorIdentify (Added second input)
        getcolorArry stOutput, ColorsOutput;
        FOR j FROM 1 TO 9 DO
            IF stOutput{j}="No Match" THEN
                TPWrite "3 No Match";
                ColorWrong;
            ENDIF
            SideColors{3}:=SideColors{3}+stOutput{j};
            
            !Added TCH ColorIdentify
            ! Cycle through each colorspace value
            FOR k FROM 1 TO 6 DO
                SideColorValues{3,j,k}:=ColorsOutput{j,k};
            ENDFOR
            
        ENDFOR
        
        MoveL RelTool(pCamera01, 0, 0, 0 \Rz:=180), RightArmVelocity, fine, ServoR;
        !WaitTime 1;

        !Modified TCH ColorIdentify (Added second input)
        getcolorArry stOutput, ColorsOutput;
        FOR j FROM 1 TO 9 DO
            IF stOutput{j}="No Match" THEN
                TPWrite "1 No Match";
                ColorWrong;
            ENDIF
            SideColors{1}:=SideColors{1}+stOutput{j};
            
            !Added TCH ColorIdentify
            ! Cycle through each colorspace value
            FOR k FROM 1 TO 6 DO
                SideColorValues{1,j,k}:=ColorsOutput{j,k};
            ENDFOR
            
        ENDFOR
        
!        MoveJ pCamera01, RightArmVelocity, z30, ServoR; 
!        !WaitTime 1;
!        getcolorArry stOutput;
!        FOR j FROM 1 TO 9 DO
!            IF stOutput{j}="No Match" THEN
!                TPWrite "3 No Match";
!                ColorWrong;
!            ENDIF
!            SideColors{3}:=SideColors{3}+stOutput{j};
!        ENDFOR
        
        MoveJ pCamera02, RightArmVelocity, z30, ServoR; 
        
    ENDPROC
    
    PROC CaptureSurface5_RightArm()
        VAR robtarget ptemp_01;
        
        WaitSyncTask CaptureSurface5_sync1, all_tasks;
        MoveL p11, RightArmVelocity, fine, ServoR;
        MoveL RelTool(p11, 0, 0, 0 \Rz:=90), RightArmVelocity, fine, ServoR;
        
        WaitSyncTask CaptureSurface5_sync2, all_tasks;
        
        WaitSyncTask CaptureSurface5_sync3, all_tasks;
        GripperRelease;
        ptemp_01:=CRobT(\Tool:=ServoR);
        MoveL RelTool(ptemp_01, 0, 0, -38), RightArmVelocity, fine, ServoR;
        MoveJ p10, RightArmVelocity, fine, ServoR;     
        
        WaitSyncTask CaptureSurface5_sync4, all_tasks;
        
        WaitSyncTask CaptureSurface5_sync5, all_tasks;
        MoveL p11, RightArmVelocity, fine, ServoR;
        GripperGrip;
        
        WaitSyncTask CaptureSurface5_sync6, all_tasks;
        
        WaitSyncTask CaptureSurface5_sync7, all_tasks;
        MoveJ pCamera02, RightArmVelocity, z30, ServoR;
        MoveJ pCamera01, RightArmVelocity, fine, ServoR; 
       ! MoveL pCamera01, RightArmVelocity, fine, ServoR; 
        
        !WaitTime 1;
        
        !Modified TCH ColorIdentify (Added second input)
        getcolorArry stOutput, ColorsOutput;
        FOR j FROM 1 TO 9 DO
            IF stOutput{j}="No Match" THEN
                TPWrite "4 No Match";
                ColorWrong;
            ENDIF
            SideColors{4}:=SideColors{4}+stOutput{j};
            
            !Added TCH ColorIdentify
            ! Cycle through each colorspace value
            FOR k FROM 1 TO 6 DO
                SideColorValues{4,j,k}:=ColorsOutput{j,k};
            ENDFOR
        ENDFOR
        
        MoveL RelTool(pCamera01, 0, 0, 0 \Rz:=180), RightArmVelocity, fine, ServoR;
        !WaitTime 1;
        
        !Modified TCH ColorIdentify (Added second input)
        getcolorArry stOutput, ColorsOutput;
        FOR j FROM 1 TO 9 DO
            IF stOutput{j}="No Match" THEN
                TPWrite "2 No Match";
                ColorWrong;
            ENDIF
            SideColors{2}:=SideColors{2}+stOutput{j};
            
            !Added TCH ColorIdentify
            ! Cycle through each colorspace value
            FOR k FROM 1 TO 6 DO
                SideColorValues{2,j,k}:=ColorsOutput{j,k};
            ENDFOR
        ENDFOR
        MoveJ pCamera02, RightArmVelocity, z30, ServoR; 
        
    ENDPROC
    
    PROC CaptureSurface3_RightArm()
        VAR robtarget ptemp_01;
        
        WaitSyncTask CaptureSurface3_sync1, all_tasks;
        MoveL p11, RightArmVelocity, fine, ServoR;
        MoveL RelTool(p11, 0, 0, 0 \Rz:=90), RightArmVelocity, fine, ServoR;
        
        WaitSyncTask CaptureSurface3_sync2, all_tasks;
        
        WaitSyncTask CaptureSurface3_sync3, all_tasks;
        GripperRelease;
        ptemp_01:=CRobT(\Tool:=ServoR);
        MoveL RelTool(ptemp_01, 0, 0, -38), RightArmVelocity, fine, ServoR;
        MoveJ p10, RightArmVelocity, fine, ServoR;     
        
        WaitSyncTask CaptureSurface3_sync4, all_tasks;
        
        WaitSyncTask CaptureSurface3_sync5, all_tasks;
        MoveL p11, RightArmVelocity, fine, ServoR;
        GripperGrip;
        
        WaitSyncTask CaptureSurface3_sync6, all_tasks;
        
        WaitSyncTask CaptureSurface3_sync7, all_tasks;
        
        MoveJ pCamera02, RightArmVelocity, z30, ServoR; 
        MoveJ pCamera01, RightArmVelocity, fine, ServoR; 
        
        !WaitTime 1;
        
        !Modified TCH ColorIdentify (Added second input)
        getcolorArry stOutput, ColorsOutput;
        FOR j FROM 1 TO 9 DO
            IF stOutput{j}="No Match" THEN
                TPWrite "6 No Match";
                ColorWrong;
            ENDIF
            SideColors{6}:=SideColors{6}+stOutput{j};
            
            !Added TCH ColorIdentify
            ! Cycle through each colorspace value
            FOR k FROM 1 TO 6 DO
                SideColorValues{6,j,k}:=ColorsOutput{j,k};
            ENDFOR
        ENDFOR
        
        MoveL RelTool(pCamera01, 0, 0, 0 \Rz:=180), RightArmVelocity, fine, ServoR;
        !WaitTime 1;
        
        !Modified TCH ColorIdentify (Added second input)
        getcolorArry stOutput, ColorsOutput;
        FOR j FROM 1 TO 9 DO
            IF stOutput{j}="No Match" THEN
                TPWrite "5 No Match";
                ColorWrong;
            ENDIF
            SideColors{5}:=SideColors{5}+stOutput{j};
            
            !Added TCH ColorIdentify
            ! Cycle through each colorspace value
            FOR k FROM 1 TO 6 DO
                SideColorValues{5,j,k}:=ColorsOutput{j,k};
            ENDFOR
        ENDFOR
        
        MoveJ pCamera02, RightArmVelocity, z30, ServoR; 
        MoveJ p11, RightArmVelocity, Fine, ServoR;
        
    ENDPROC
    
    PROC ReadyForSolving_RightArm()
        WaitSyncTask ReadyForSolving_sync1, all_tasks;
        MoveJ p11, RightArmVelocity, Fine, ServoR;
        !GripperGrip;
        
    ENDPROC
    
    
    
    
ENDMODULE