MODULE DisorderCube_L

    VAR intnum i_flick;
    
    TRAP t_flick
        
        reset custom_do_7;
        waittime 0.15;
        !Set custom_do_7;
        
    ENDTRAP
    
    PROC DisorderCube_LeftArm()

        MoveFrom5to1_LeftArm;
        MoveJ p31,LeftArmVelocity,fine,ServoL;

        WaitSyncTask DisorderCube_sync1,all_tasks;

        RotateAction "L1",DisorderCubeStep{1};

        FOR i FROM 2 TO 9 DO
            RotateAction DisorderCubeStep{i-1},DisorderCubeStep{i};
        ENDFOR

        Transform StrPart(DisorderCubeStep{9},1,1),"F";

    ENDPROC

    PROC ShowAround_LeftArm()
        
        WaitSyncTask ShowAround_sync1,all_tasks;
        MoveL p41,LeftArmVelocity,fine,ServoL;
        GripperGrip;
        
        WaitSyncTask ShowAround_sync2,all_tasks;
        
        WaitSyncTask ShowAround_sync3,all_tasks;
        MoveJ p60,v200,z10,ServoL;
        
        !*****************
        IF not solveable THEN 
            nHMI_States:=5;
        PutDowm_LeftArm;
        rHome;            
        ExitCycle;
        ENDIF      
        !***************
        MoveJ p61,v200,z10,ServoL;
        MoveJ p62,v200,z10,ServoL;
        !MoveJ p63,v200,z1,ServoL;
        MoveJ p62,v200,z10,ServoL;
        MoveJ p61,v200,z10,ServoL;
        MoveJ p60,v200,z10,ServoL;
        
        WaitSyncTask ShowAround_sync4,all_tasks;
        MoveJ p41,v200,fine,ServoL;
        
        WaitSyncTask ShowAround_sync5,all_tasks;
        
        WaitSyncTask ShowAround_sync6,all_tasks;
        GripperRelease;
        MoveL p40,LeftArmVelocity,fine,ServoL;
        
    ENDPROC
    
    PROC ShowResult_LeftArm()
!        
        CONNECT i_flick WITH t_flick;
        ITimer 0.2,i_flick;
        
        WaitSyncTask ShowResult_sync1,all_tasks;
         nHMI_States:=4;
        MoveL p70, v300, z10, ServoL;
        MoveL p71, v300, z10, ServoL;
        MoveL p72, v300, z10, ServoL;
        MoveL p73, v300, z10, ServoL;
        
        WaitSyncTask ShowResult_sync2,all_tasks;
        MoveL p74,v300,z30,ServoL;
        
        WaitSyncTask ShowResult_sync3,all_tasks;
        MoveL p75,v300,z30,ServoL;
        MoveL p74,v300,z30,ServoL;
        
        WaitSyncTask ShowResult_sync4,all_tasks;
        MoveL p75,v300,z30,ServoL;
        MoveL p74,v300,z30,ServoL;
        
        MoveL p73,v300,z30,ServoL;
        
        WaitSyncTask ShowResult_sync5,all_tasks;
        MoveL p72,v300,z30,ServoL;
        MoveL p71,v300,z30,ServoL;
        MoveL p70,v300,z30,ServoL;
        
        IDelete i_flick;
       
    ENDPROC

ENDMODULE