MODULE MotionForCamera_L

    PROC Initiate_LeftArm()
        GripperRelease;
        MoveJ RelTool(p903,0,0,-50), LeftArmVelocity, z5, ServoL;
        MoveL p903,v200,fine,ServoL;
        !p903 is the capture position
        WaitTime 0.5;
        GripperGrip;
        !MoveL p902,LeftArmVelocity,z20,ServoL;
        !MoveJ RelTool(p903,0,0,-50), LeftArmVelocity, z5, ServoL;
        Movel OFFS(p903,0,0,50), LeftArmVelocity, z5, ServoL;
        !MoveJ p40,LeftArmVelocity,fine,ServoL;
        Movej p41,LeftArmVelocity,Fine,ServoL;
        IF hand_ActualPosition_L<10 THEN
            ExitCycle;
        ENDIF
    ENDPROC

    PROC CaptureSurface0_LeftArm()
        WaitSyncTask CaptureSurface0_sync1,all_tasks;

        WaitSyncTask CaptureSurface0_sync2,all_tasks;
        GripperRelease;
        MoveL p40,LeftArmVelocity,fine,ServoL;

        WaitSyncTask CaptureSurface0_sync3,all_tasks;


    ENDPROC

    PROC CaptureSurface5_LeftArm()
        VAR robtarget ptemp_01;

        WaitSyncTask CaptureSurface5_sync1,all_tasks;
        MoveL RelTool(p40,0,0,0\Rz:=-90),LeftArmVelocity,fine,ServoL;

        WaitSyncTask CaptureSurface5_sync2,all_tasks;
        ptemp_01:=CRobT(\Tool:=ServoL);
        MoveL RelTool(ptemp_01,0,0,38),LeftArmVelocity,fine,ServoL;
        GripperGrip;

        WaitSyncTask CaptureSurface5_sync3,all_tasks;

        WaitSyncTask CaptureSurface5_sync4,all_tasks;
        MoveJ p41,LeftArmVelocity,Fine,ServoL;

        WaitSyncTask CaptureSurface5_sync5,all_tasks;

        WaitSyncTask CaptureSurface5_sync6,all_tasks;
        GripperRelease;
        MoveL p40,LeftArmVelocity,fine,ServoL;

        WaitSyncTask CaptureSurface5_sync7,all_tasks;


    ENDPROC

    PROC CaptureSurface3_LeftArm()
        VAR robtarget ptemp_01;

        WaitSyncTask CaptureSurface3_sync1,all_tasks;
        MoveL RelTool(p40,0,0,0\Rz:=-90),LeftArmVelocity,fine,ServoL;

        WaitSyncTask CaptureSurface3_sync2,all_tasks;
        ptemp_01:=CRobT(\Tool:=ServoL);
        MoveL RelTool(ptemp_01,0,0,38),LeftArmVelocity,fine,ServoL;
        GripperGrip;

        WaitSyncTask CaptureSurface3_sync3,all_tasks;

        WaitSyncTask CaptureSurface3_sync4,all_tasks;
        MoveJ p41,LeftArmVelocity,Fine,ServoL;

        WaitSyncTask CaptureSurface3_sync5,all_tasks;

        WaitSyncTask CaptureSurface3_sync6,all_tasks;
        GripperRelease;
        MoveL p40,LeftArmVelocity,fine,ServoL;

        WaitSyncTask CaptureSurface3_sync7,all_tasks;


    ENDPROC

    PROC ReadyForSolving_LeftArm()
        WaitSyncTask ReadyForSolving_sync1,all_tasks;
        MoveFrom5to1_LeftArm;
        MoveJ p10,LeftArmVelocity,fine,ServoL;
    ENDPROC

    PROC PutDowm_LeftArm()
        MoveJ p40,LeftArmVelocity,Fine,ServoL;
        !MoveJ p901,LeftArmVelocity,z20,ServoL;
        MoveJ offs(p903,0,0,50),LeftArmVelocity,z20,ServoL;
        MoveL offs(p903,0,0,5),v150,fine,ServoL;
    !    MoveL p903,v100,fine,ServoL;
        WaitTime 0.5;
        GripperRelease;
        !MoveL p902,LeftArmVelocity,z5,ServoL;
        MoveL RelTool(p903,0,0,-50),LeftArmVelocity,z20,ServoL;
    ENDPROC



ENDMODULE